/*
    imbLoader.h
    Loader plug-in for Irrlicht engine.

    MUTATE Systems 2018 (https://mutate.jp)
*/

#pragma once
#include <irrlicht.h>
#include <list>

class ImbMeshModifier {
public:
    virtual void onLoadImbCompleted(const irr::io::path& filename, struct SIrrMeshBuild* pimb) {};
    virtual void onBuildMeshCompleted(const irr::io::path& filename, irr::scene::ISkinnedMesh* pMesh) {};
};

class ImbLoader : public irr::scene::IMeshLoader {
public:
    explicit ImbLoader(irr::scene::ISceneManager* smgr, const char* szTxDir);
    virtual ~ImbLoader();

    virtual irr::scene::IAnimatedMesh* createMesh(irr::io::IReadFile* file);
    virtual bool isALoadableFileExtension(const irr::io::path& filename) const;
    void addMeshModifier(ImbMeshModifier* pModifier);

protected:
    irr::scene::ISceneManager* m_smgr;
    const char* m_szTxDir;
    std::list<ImbMeshModifier*> m_modifiers;
};
